// Made by Vtastek
// Want to learn shaders ---> https://thebookofshaders.com/

texture lastshader;

sampler s0 = sampler_state { texture = <lastshader>; addressu = mirror; addressv = mirror; magfilter = point; minfilter = point; };


extern float srange = 0.0;
extern float sspeed = 0.0;
extern float zoom = 1.0;

extern float offset = 0.0;
extern float intensity = 0.0;
extern float vibright = 0.5;

float seed = 5; //integer
float time;

float rand(float2 co) {
    return frac(sin(dot(co.xy ,float2(12.9898, 78.233))) * 43758.5453);
}

float4 shakervib(in float2 tex:TEXCOORD0): COLOR0
{
    float i = floor(time * sspeed * srange);          // integer
    float f = frac(time * sspeed * srange );          // fraction
	float iy = floor(time * sspeed * srange + seed);  // integer
    float fy = frac(time * sspeed * srange );         // fraction
    float randy = lerp(rand(i), rand(i + 1.0), smoothstep(0.0, 1.0, f));
    float randx = lerp(rand(iy), rand(iy + 1.0), smoothstep(0.0, 1.0, fy));

    float2 scaleCenter = float2(0.5f, 0.5f);
    tex = (tex - scaleCenter) * zoom + scaleCenter;

    float2 stex = tex + (float2(randx, randy) - 0.5) * srange * 0.0015;

	float4 final = tex2D(s0, stex);

	float4 finalleft = tex2D(s0, stex-float2(offset, 0));
	float4 finalright = tex2D(s0, stex+float2(offset, 0));

	final = (1 + offset * vibright) *  lerp(final, lerp(finalleft, finalright, 0.5), min(offset * intensity, 0.5));


    return final;
}

technique T0 < string MGEinterface="MGE XE 0"; >
{
    pass { PixelShader = compile ps_3_0 shakervib(); }
}
